import type { DebounceSettings, ThrottleSettings } from 'lodash';
export declare const cleanup: () => void;
/**
 * Makes methods debounced
 * @param wait
 * @param options
 * @returns
 */
export declare const debounced: (wait?: number, options?: DebounceSettings) => (originalMethod: any, context: ClassMethodDecoratorContext) => void;
/**
 * Makes methods throttled
 * @param wait
 * @param options
 * @returns
 */
export declare const throttled: (wait?: number, options?: ThrottleSettings) => (originalMethod: any, context: ClassMethodDecoratorContext) => void;
