export type AgoraUploadTask = {
    id: number;
    file: File;
};
export interface AgoraUploadObserver {
    onUploadFailure?(error: Error, task: AgoraUploadTask): void;
    onUploadSuccess?(task: AgoraUploadTask): void;
}
export interface AgoraUploadHandler<T extends AgoraUploadTask> {
    handleUpload(task: T): Promise<void>;
}
