type EventParameters<T> = T extends (...args: infer U) => any ? U : never;
export declare class AgoraObservable<T> {
    private _eventBus;
    private _observers;
    private _observerSet;
    addObserver(observer: T): void;
    removeObserver(observer: T): void;
    notifyObservers<K extends keyof T>(eventName: K, ...args: EventParameters<T[K]>): void;
    countOfObservers(): number;
}
export {};
