"use strict";

require("core-js/modules/es.object.define-property.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.timeout = void 0;
require("core-js/modules/es.error.cause.js");
require("core-js/modules/es.error.to-string.js");
require("core-js/modules/es.array.iterator.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.promise.js");
require("core-js/modules/es.string.iterator.js");
require("core-js/modules/web.dom-collections.iterator.js");
require("core-js/modules/web.timers.js");
var timeout = exports.timeout = function timeout(p, ms) {
  return Promise.race([p, new Promise(function (_, reject) {
    setTimeout(function () {
      return reject(new Error('race condition timeout', {
        cause: 'timeout'
      }));
    }, ms);
  })]);
};