import Dexie, { Table } from 'dexie';
type Timestamp = number;
export type LogSchema = {
    id: number;
    content: string;
    label: string;
    created_at: Timestamp;
    timestamp: string;
};
export type TempLogs = {
    id: number;
    data: Blob;
};
export declare class LoggerDB extends Dexie {
    logs: Table<LogSchema, number>;
    tempLogs: Table<TempLogs, number>;
    constructor();
    openDatabase(): void;
}
export declare const db: LoggerDB;
export {};
