"use strict";

require("core-js/modules/es.object.define-property.js");
require("core-js/modules/es.reflect.construct.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.db = exports.LoggerDB = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _dexie = _interopRequireDefault(require("dexie"));
function _callSuper(t, o, e) { return o = (0, _getPrototypeOf2["default"])(o), (0, _possibleConstructorReturn2["default"])(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], (0, _getPrototypeOf2["default"])(t).constructor) : o.apply(t, e)); }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
var DATABASE_NAME = "AgoraLogger";
var TABLE_NAME_LOGS = "logs";
var TABLE_NAME_LOGS_TEMP_BUFFERS = "tempLogs";
var LoggerDB = exports.LoggerDB = /*#__PURE__*/function (_Dexie) {
  function LoggerDB() {
    var _this;
    (0, _classCallCheck2["default"])(this, LoggerDB);
    _this = _callSuper(this, LoggerDB, [DATABASE_NAME]);
    _this.openDatabase();
    _this.logs = _this.table(TABLE_NAME_LOGS);
    _this.tempLogs = _this.table(TABLE_NAME_LOGS_TEMP_BUFFERS);
    return _this;
  }
  (0, _inherits2["default"])(LoggerDB, _Dexie);
  return (0, _createClass2["default"])(LoggerDB, [{
    key: "openDatabase",
    value: function openDatabase() {
      this.version(2).stores({
        logs: '++id, content, label, created_at',
        tempLogs: '++id, data'
      });
    }
  }]);
}(_dexie["default"]);
var db = exports.db = new LoggerDB();