import { WorkerContext } from '../type';
type Log = {
    content: string;
    label: string;
    created_at: number;
    timestamp: string;
};
export declare const writeLog: (self: WorkerContext, callId: number, log: Log) => void;
export declare const collectLogs: (self: WorkerContext, callId: number, labels: string[]) => Promise<void>;
export declare const deleteLogs: (self: WorkerContext, callId: number, labels: string[], lastId: number) => Promise<void>;
export declare const setMaxRecords: (self: WorkerContext, callId: number, max: number) => void;
export {};
