"use strict";

require("core-js/modules/es.object.define-property.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Mutex = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.promise.js");
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var Mutex = exports.Mutex = /*#__PURE__*/function () {
  function Mutex() {
    (0, _classCallCheck2["default"])(this, Mutex);
    (0, _defineProperty2["default"])(this, "mutex", Promise.resolve());
  }
  return (0, _createClass2["default"])(Mutex, [{
    key: "_lock",
    value: function _lock() {
      var begin = function begin() {};
      this.mutex = this.mutex.then(function () {
        return new Promise(begin);
      });
      return new Promise(function (res) {
        begin = res;
      });
    }
  }, {
    key: "dispatch",
    value: function () {
      var _dispatch = (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee(fn) {
        var unlock;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return this._lock();
            case 2:
              unlock = _context.sent;
              _context.prev = 3;
              _context.next = 6;
              return Promise.resolve(fn());
            case 6:
              return _context.abrupt("return", _context.sent);
            case 7:
              _context.prev = 7;
              unlock();
              return _context.finish(7);
            case 10:
            case "end":
              return _context.stop();
          }
        }, _callee, this, [[3,, 7, 10]]);
      }));
      function dispatch(_x) {
        return _dispatch.apply(this, arguments);
      }
      return dispatch;
    }()
  }]);
}();