"use strict";

require("core-js/modules/es.object.define-property.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LogManagerImpl = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var LogManagerImpl = exports.LogManagerImpl = /*#__PURE__*/function () {
  function LogManagerImpl(_logWorkerInteractor) {
    (0, _classCallCheck2["default"])(this, LogManagerImpl);
    (0, _defineProperty2["default"])(this, "_lastId", -1);
    this._logWorkerInteractor = _logWorkerInteractor;
  }
  return (0, _createClass2["default"])(LogManagerImpl, [{
    key: "flush",
    value: function () {
      var _flush = (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee() {
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              this._logWorkerInteractor.deleteLogs(['default'], this._lastId);
            case 1:
            case "end":
              return _context.stop();
          }
        }, _callee, this);
      }));
      function flush() {
        return _flush.apply(this, arguments);
      }
      return flush;
    }()
  }, {
    key: "collectLogs",
    value: function () {
      var _collectLogs = (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee2() {
        var _yield$this$_logWorke, file, lastId;
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return this._logWorkerInteractor.collectLogs(['default']);
            case 2:
              _yield$this$_logWorke = _context2.sent;
              file = _yield$this$_logWorke.file;
              lastId = _yield$this$_logWorke.lastId;
              this._lastId = lastId;
              return _context2.abrupt("return", file);
            case 7:
            case "end":
              return _context2.stop();
          }
        }, _callee2, this);
      }));
      function collectLogs() {
        return _collectLogs.apply(this, arguments);
      }
      return collectLogs;
    }()
  }]);
}();