import { AgoraUploadTask, AgoraUploadHandler, AgoraUploadObserver } from "./type";
export declare class AgoraUploadScheduler<T extends AgoraUploadTask> {
    private _uploadHandler;
    private _eventEmitter;
    private _taskQueue;
    private _isProcessing;
    private _retryDelay;
    constructor(_uploadHandler: AgoraUploadHandler<T>);
    setRetryDelay(delay: number): void;
    addUploadTask(task: T): void;
    prependUploadTask(task: T): void;
    addObserver(observer: AgoraUploadObserver): void;
    removeObserver(observer: AgoraUploadObserver): void;
    private _notifyQueueChanged;
}
