/**
 * 事件发射器
 */
/**@en
 * Event emitter
 */
export declare class AgoraEventEmitter {
    once(evt: string, cb: CallableFunction): this;
    on(evt: string, cb: CallableFunction): this;
    off(evt: string, cb: CallableFunction): this;
    removeAllEventListeners(): void;
    emit(evt: string, ...args: any[]): this;
}
