export type Interceptor<T = unknown> = (evt: T) => Result;
export declare enum Result {
    BREAK = 0,
    CONTINUE = 1
}
export declare const chain: <T>(...interceptors: Interceptor<T>[]) => Interceptor<T>;
